/*
 * Copyright (C) 2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */


#ifndef INCL_LOC_UTILS
#define INCL_LOC_UTILS

#include <map>

class localizationUtils{

    public:

        __declspec(dllexport) static localizationUtils* getInstance();
        __declspec(dllexport) static bool isInstantiated();

        __declspec(dllexport) ~localizationUtils();

        __declspec(dllexport) HINSTANCE getLocaleResource();
        __declspec(dllexport) const wchar_t* getLocalizationString(UINT VALUE);

        void showMessage(UINT VALUE);

    private:

        static localizationUtils* pinstance;

        std::wstring internalBuffer;

        localizationUtils(const localizationUtils&) {}

        localizationUtils();

        std::map<int,const wchar_t*> langCodes;

        /**
        * The instance of the loaded localization resource library
        */
        HINSTANCE localeResource;

        void initLangCodes();

        void setLocaleResource();

};

// void showMessage(UINT VALUE);

__declspec(dllexport) localizationUtils* getLocalizationUtils();

#endif