/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */


#ifndef __ADDRESS_CHANGE_H
#define __ADDRESS_CHANGE_H

enum AN_ResponseCode {
    AN_AddressAccepted = 0,
    AN_AddressNotValid,
    AN_ServerUnreachable,
    AN_InvalidConfig,
    AN_Unspecified = 255
};

/**
 * This function sends the current IP address to the server,
 * using the initial alert message, with a proper code (745),
 * sent to a dedicated uri of the server.
 *
 * @param context - the root config context in the DM.
 *
 * @return - a code to report the result of the operation:
 *           0 if the client is notifieble (success)
 *           the error code (!= 0) in case of errors or if the client is not notifieble
 */
int notifyAddressChange(const wchar_t *context);


/**
 * Displays a timed msgbox for invalid credentials.
 * @param  statusCode   the code of status received (401/402/...)
 * @param  timout [optional] the timeout for the messagebox (in seconds)
 */
void showInvalidCredentialsMsgBox(int statusCode, int timeout = 10);


#endif

