/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
#include "pim/OutlookApp.h"
#include "base/Log.h"

OutlookApp * OutlookApp::instance = 0;

OutlookApp::OutlookApp() {

    polApp = NULL;
    initialize();
}

OutlookApp::~OutlookApp() {
    if (polApp) {
        polApp->Logoff ();
        polApp->Release ();
    }
    polApp = NULL;
}

OutlookApp* OutlookApp::getInstance() {

	if(instance == NULL) {
		instance = new OutlookApp();
	}
	return instance;
}

void OutlookApp::dispose() {

	if(instance) {
		delete instance;
	}
	instance = NULL;
}

void OutlookApp::initialize() {

    HRESULT hr;
    if (FAILED (CoInitializeEx (NULL, 0))) {
        LOG.error("OutlookApp error: CoInitializeEx failed");
        return;
    }
/*
* instantiate the IPOutlookApp (for wm2003) or IPOutlookApp2 (for wm5)
*/ 
#if _WIN32_WCE > 0x500 
    hr = CoCreateInstance (CLSID_Application, NULL, CLSCTX_INPROC_SERVER, IID_IPOutlookApp2, (LPVOID*)&polApp);
#else
    hr = CoCreateInstance (CLSID_Application, NULL, CLSCTX_INPROC_SERVER, IID_IPOutlookApp, (LPVOID*)&polApp);
#endif
    
    if (FAILED(hr)) {
        LOG.error("OutlookApp error: the outlook application cannot be created");
        return;
    }
    hr = polApp->Logon (NULL);
    if (FAILED (hr)) {
        LOG.error("OutlookApp error: the outlook application cannot be logged in");
    }
   
}