/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#include "processUtils.h"
#include "pim/ClientSettings.h"
#include "base/startcmd.h"

int startProgram(const wchar_t *app, const wchar_t *cmdline)
{   
    PROCESS_INFORMATION procinfo;
     
    wchar_t *path = NULL;
    path = toWideChar(getRegConfig()->getPath().c_str());
    wstring cmd;
    
    if (path) {
        cmd += path;
        delete [] path;
    }
    cmd += TEXT("\\"); cmd += app;

    LOG.debug("Running: %ls %ls\n", cmd.c_str(), cmdline);
    if( CreateProcess( cmd.c_str(), cmdline,
                        NULL, NULL, FALSE, 0,
                        NULL, NULL, NULL, &procinfo ) ) {
        return procinfo.dwProcessId;
    }
    else {
        //-- maybe the Registry entry is missing, trying startcmd()
        int pid = startcmd(app, cmdline);
        return pid;
    }
}
