/*
 * Copyright (C) 2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */


#ifndef __CUSTOMIZATION_H
#define __CUSTOMIZATION_H

// Set this to change the place where the configuration is stored
// in the registry, starting from HKLM/Software
#define ROOT_CONTEXT                    "Funambol/SyncclientPIM"
#define ROOT_CONTEXT_W                  TEXT("Funambol\\SyncclientPIM")

// Set this to the name of the manufacturer
#define PROVIDER                        "Funambol"

// This is the name of the link in the Start Menu.
#define APP_NAME                        PROVIDER

// The name of the Funambol Email used in the wap-provisioningdoc method
#define ACCOUNT_NAME_TO_CREATE          TEXT(PROVIDER)

// The name of the Funambol Email used to search the account name
// It is needed another variable to escape the ampersand
#define ACCOUNT_NAME                    TEXT(PROVIDER)

// URL showed in the About box.
#define APP_LINK                        "www.funambol.com"

// Domain of funambol Email account (optional)
#define DOMAIN_NAME                     L"funambol.com"

// The incoming/outgoing Email Server
#define INCOMING_MAIL_SERVER            L"sync.funambol.com"
#define OUTGOING_MAIL_SERVER            L"sync.funambol.com"

// The unique GUID of the Email account
#define ACCOUNT_GUID                    L"{F9043C85-F6F2-101A-A3C9-08002B2F49FB}"


// Conditional defines for various customizable features.

// If set to 1, hides the URL in the communication settings.
#define FUNOPT_SHOW_URL             1
#define FUNOPT_SHOW_DEV_INFO        0
#define FUNOPT_SHOW_COPYRIGHT       1

#endif
