/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#include "CTPParam.h"

CTPParam::CTPParam() {
    value = NULL;
    paramCode = -1;
    valueLength = -1;
}

CTPParam::~CTPParam() {
    if (value) {
        delete [] value; value = NULL;
    }    
    
}

CTPParam::CTPParam(const CTPParam& cp) {
    value = NULL;
    setValue(cp.getValue(), cp.getValueLength());
    setParamCode(cp.getParamCode());
}

void* CTPParam::setValue(const void* v, long length) {
    
    if (value) {
       delete [] value; value = NULL;
    }

    valueLength = length;

    // Not yet set.
    if (valueLength <= 0) {
        value = NULL;
        return value;
    }

    value = new char[valueLength];
    if (value == NULL) {
        LOG.error("Not enough memory to allocate the internal ctp buffer");
        return NULL;
    }

    if (v) {
        memcpy(value, v, valueLength);       
    } else {
        memset(value, 0, valueLength);
    }

    return value;

}
